function lec5_manipulator_inverse_kinematics
clc
close all
clear all

l1 = 1; l2 = 1;
x_ref = 0.5; y_ref = 0;
param = [l1 l2 x_ref y_ref];

x0 = [1 0];
[x,fval,exitflag] = fsolve(@myfun,x0,optimoptions('fsolve','Display','iter'),param)
 x
 fval
 exitflag
%%%%%%%%% define parameters %%%%%

theta1 = x(1); theta2 = x(2);

%%%% origin of the world/fixed frame %%%
x_O0 = 0; y_O0 = 0;

%%%%%%% end of link1 or elbow in world frame %%%
x_P = l1*cos(theta1); y_P = l1*sin(theta1);

%%%% end of link2 or tip of hand in world frame %%%
x_Q = l1*cos(theta1)+l2*cos(theta1+theta2);
y_Q = l1*sin(theta1)+l2*sin(theta1+theta2);

%%%%%%%% draw line to generate the manipulator
line([x_O0 x_P],[y_O0 y_P],'Linewidth',5,'Color',[192,192,192]/255);
line([x_P x_Q],[y_P y_Q],'Linewidth',5,'Color','g');

axis('equal');
axis([-2 2 -2 2]);
grid on
xlabel('x');
ylabel('y');
title('Forward kinematics');

function F = myfun(x,param)
%param = [l1 l2 x_ref y_ref];
l1 = param(1); l2 = param(2);
x_ref = param(3); y_ref = param(4);
theta1 = x(1);
theta2 = x(2);

x_Q = l1*cos(theta1)+l2*cos(theta1+theta2);
y_Q = l1*sin(theta1)+l2*sin(theta1+theta2);
F = [x_Q - x_ref; y_Q - y_ref];